﻿; ===========================================================================================================
;:      ___   ________  ______    ______   ___      ___    _______   __    ___       _______   _______   
;      |"  | /"       )/" _  "\  /    " \ |"  \    /"  |  |   __ "\ |" \  |"  |     /"     "| /"      \  
;      ||  |(:   \___/(: ( \___)// ____  \ \   \  //   |  (. |__) :)||  | ||  |    (: ______)|:        | 
;      |:  | \___  \   \/ \    /  /    ) :)/\\  \/.    |  |:  ____/ |:  | |:  |     \/    |  |_____/   ) 
;   ___|  /   __/  \\  //  \ _(: (____/ //|: \.        |  (|  /     |.  |  \  |___  // ___)_  //      /  
;  /  :|_/ ) /" \   :)(:   _) \\        / |.  \    /:  | /|__/ \    /\  |\( \_|:  \(:      "||:  __   \  
; (_______/ (_______/  \_______)\"_____/  |___|\__/|___|(_______)  (__\_|_)\_______)\_______)|__|  \___) 
; ===========================================================================================================
; Library for simple usage of JS-Scripts in PureBasic

  Procedure.s _JSc_Generate(Script$, ParamIn$, RunOnce.l, jq.b)
    gen.s = "<html>"
    gen.s + "<head>"
    gen.s + "<meta http-equiv='X-UA-Compatible' content='IE=edge' />"
    gen.s + "<title>" + #JSc_Busy + "</title>"
    gen.s + "</head>"
    gen.s + "<body>"
    gen.s + "<script>"
    
    If jq = 1
      f = ReadFile(#PB_Any, "_jq.txt")
      If f
        While Eof(f) = 0
          gen.s + ReadString(f)
        Wend 
        CloseFile(f)
        gen.s + "</script><script>"
      EndIf 
    EndIf 
    
    ;Inject Arguments
    gen.s + "var args = JSON.parse('" + ParamIn$  +"');"
    
    If RunOnce <= 0  ;Inject UpdateFunction
      gen.s + "function jsc_update(){"
        gen.s + "var title = document.title;"
        gen.s + "if(title.substring(0,3) == '#*U'){"
          gen.s + "title = title.substring(3);"
          gen.s + "args = JSON.parse(title);"
          gen.s + "document.title = '"+ #JSc_Busy +"';"
        gen.s + "}"
      gen.s + "}"
      gen.s + "window.setInterval('jsc_update()', 200);"
    EndIf 
    
    ;Inject ReturnFunction
    gen.s + "function jsc_return(pOut){"
    gen.s + "pOut = JSON.stringify(pOut);"
    gen.s + "if(pOut=='') pOut='undefined';"
    gen.s + "document.title = pOut;"
    gen.s + "}"
    
    gen.s + Script$
    
    gen.s + "</script>"
    gen.s + "</body>"
    gen.s + "</html>"
    
    ProcedureReturn gen.s
  EndProcedure 
  
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
  Procedure JSc_IDLE()
    
    ForEach _JSc_Scripts()
      ;Skip if not found - maybe delete
      If Not IsGadget(_JSc_Scripts()\WebGadget) Or _JSc_Scripts()\Ready = 1 : Continue : EndIf 
      
      ;InjectCode with Parameters and run
      If Not _JSc_Scripts()\Generated
        Script$ = _JSc_Generate(_JSc_Scripts()\Script, _JSc_Scripts()\ParamIn, _JSc_Scripts()\RunOnce, _JSc_Scripts()\jq)
        _JSc_Scripts()\Generated = 1
        _JSc_Scripts()\ParamIn   = #JSc_Ready
        SetGadgetItemText(_JSc_Scripts()\WebGadget,#PB_Web_HtmlCode, Script$)
        SetGadgetItemText(_JSc_Scripts()\WebGadget, #PB_Web_PageTitle, #JSc_Busy)
        SetClipboardText(Script$)
      EndIf 
      
      ;Inject new Parameters
      If _JSc_Scripts()\ParamIn <> #JSc_Ready
        SetGadgetItemText(_JSc_Scripts()\WebGadget, #PB_Web_PageTitle, "#*U" + _JSc_Scripts()\ParamIn)
        _JSc_Scripts()\ParamIn   = #JSc_Ready
      EndIf 
      
      ;Get Results
      _JSc_Scripts()\ParamOut = GetGadgetItemText(_JSc_Scripts()\WebGadget, #PB_Web_PageTitle)
      
      ;Run Once?
      If _JSc_Scripts()\ParamOut <> #JSc_Busy And _JSc_Scripts()\ParamOut <> ""
        If _JSc_Scripts()\RunOnce = 1
          _JSc_Scripts()\Ready = 1
        Else 
          If _JSc_Scripts()\RunOnce <= -1
            If _JSc_Scripts()\RunOnce = -2 : _JSc_Scripts()\SParamIn = _JSc_Scripts()\ParamOut : EndIf 
            Script$ = _JSc_Generate(_JSc_Scripts()\Script, _JSc_Scripts()\SParamIn, _JSc_Scripts()\RunOnce, _JSc_Scripts()\jq)
            SetGadgetItemText(_JSc_Scripts()\WebGadget,#PB_Web_HtmlCode, Script$)
            SetGadgetItemText(_JSc_Scripts()\WebGadget, #PB_Web_PageTitle, #JSc_Busy)
          EndIf 
          
          SetGadgetItemText(_JSc_Scripts()\WebGadget, #PB_Web_PageTitle, #JSc_Busy)
        EndIf 
      EndIf 
    Next 
    
    ev = WindowEvent()
  EndProcedure 
  
; =========================================================================================================== EOF
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 34
; FirstLine = 11
; Folding = -
; EnableUnicode
; EnableXP
; CompileSourceDirectory