﻿; ===========================================================================================================
;:      ___   ________  ______    ______   ___      ___    _______   __    ___       _______   _______   
;      |"  | /"       )/" _  "\  /    " \ |"  \    /"  |  |   __ "\ |" \  |"  |     /"     "| /"      \  
;      ||  |(:   \___/(: ( \___)// ____  \ \   \  //   |  (. |__) :)||  | ||  |    (: ______)|:        | 
;      |:  | \___  \   \/ \    /  /    ) :)/\\  \/.    |  |:  ____/ |:  | |:  |     \/    |  |_____/   ) 
;   ___|  /   __/  \\  //  \ _(: (____/ //|: \.        |  (|  /     |.  |  \  |___  // ___)_  //      /  
;  /  :|_/ ) /" \   :)(:   _) \\        / |.  \    /:  | /|__/ \    /\  |\( \_|:  \(:      "||:  __   \  
; (_______/ (_______/  \_______)\"_____/  |___|\__/|___|(_______)  (__\_|_)\_______)\_______)|__|  \___) 
; ===========================================================================================================
; Library for simple usage of JS-Scripts in PureBasic

  #JSc_NotFound = "##*NotFound$"
  #JSc_Error    = "##*Error$"
  #JSc_Busy     = "##*Busy$"
  #JSc_Ready    = "##*Ready$"
  
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
  Structure _JSc
    RunOnce.l
    Script.s
    ParamIn.s
    SParamIn.s
    ParamOut.s
    WebGadget.l
    Generated.b
    jq.b
    Ready.b
  EndStructure 
  
 ; ===========================================================================================================
  
  Global _JSc_Window.l = 0
  Global NewMap _JSc_Scripts._JSc()
  
; ===========================================================================================================
  
  _JSc_Window = OpenWindow(#PB_Any, 0, 0, 1, 1, "JSc_Compiler", #PB_Window_Invisible | #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
  
; ===========================================================================================================
  
  Procedure JSc_Script(Name$, Script$, ParamIn$, RunOnce.l=1, jq.b=0)
    wasThere = 0
    
    If FindMapElement(_JSc_Scripts(), Name$)
      If IsGadget(_JSc_Scripts()\WebGadget) : FreeGadget(_JSc_Scripts()\WebGadget) : EndIf 
      DeleteMapElement(_JSc_Scripts())
      wasThere = 1
    EndIf 
    
    old = UseGadgetList(WindowID(_JSc_Window))
    _JSc_Scripts(Name$)\ParamIn   = ReplaceString(ParamIn$,"'",Chr(34))
    _JSc_Scripts(Name$)\SParamIn  = ReplaceString(ParamIn$,"'",Chr(34))
    _JSc_Scripts(Name$)\ParamOut  = #JSc_Busy
    _JSc_Scripts(Name$)\Script    = Script$
    _JSc_Scripts(Name$)\RunOnce   = RunOnce
    _JSc_Scripts(Name$)\WebGadget = WebGadget(#PB_Any,0,0,10,10, "")
    _JSc_Scripts(Name$)\jq        = jq
    
    If old <> 0 : UseGadgetList(old) : EndIf 
    
    ProcedureReturn 1 + wasThere
  EndProcedure 
  
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
  Procedure JSc_Script_Free(Name$)
    If FindMapElement(_JSc_Scripts(), Name$)
      If IsGadget(_JSc_Scripts()\WebGadget) : FreeGadget(_JSc_Scripts()\WebGadget) : EndIf 
      DeleteMapElement(_JSc_Scripts())
      ProcedureReturn 1
    EndIf 
    
    ProcedureReturn 0
  EndProcedure 
  
  Procedure JSc_Script_Ready(Name$)
    If FindMapElement(_JSc_Scripts(), Name$)
      ProcedureReturn _JSc_Scripts()\Ready
    EndIf 
    
    ProcedureReturn -1
  EndProcedure 
  
;::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
  
  Procedure.s JSc_Script_Out(Name$)
    If FindMapElement(_JSc_Scripts(), Name$)
      ProcedureReturn _JSc_Scripts()\ParamOut
    EndIf 
    
    ProcedureReturn #JSc_NotFound
  EndProcedure 
  
  Procedure JSc_Script_In(Name$, ParamIn$)
    If FindMapElement(_JSc_Scripts(), Name$)
      _JSc_Scripts()\ParamIn = ParamIn$
      ProcedureReturn 1
    EndIf 
    
    ProcedureReturn 0
  EndProcedure 
  
; =========================================================================================================== EOF
; IDE Options = PureBasic 5.40 LTS (Windows - x86)
; CursorPosition = 54
; FirstLine = 11
; Folding = h
; EnableUnicode
; EnableXP
; CompileSourceDirectory